# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20160918


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class BackupDestinationDetailsSummary(object):
    """
    Information about the backup destination associated with the Autonomous Container Database.
    """

    #: A constant which can be used with the type property of a BackupDestinationDetailsSummary.
    #: This constant has a value of "NFS"
    TYPE_NFS = "NFS"

    #: A constant which can be used with the type property of a BackupDestinationDetailsSummary.
    #: This constant has a value of "RECOVERY_APPLIANCE"
    TYPE_RECOVERY_APPLIANCE = "RECOVERY_APPLIANCE"

    #: A constant which can be used with the type property of a BackupDestinationDetailsSummary.
    #: This constant has a value of "OBJECT_STORE"
    TYPE_OBJECT_STORE = "OBJECT_STORE"

    #: A constant which can be used with the type property of a BackupDestinationDetailsSummary.
    #: This constant has a value of "LOCAL"
    TYPE_LOCAL = "LOCAL"

    #: A constant which can be used with the type property of a BackupDestinationDetailsSummary.
    #: This constant has a value of "DBRS"
    TYPE_DBRS = "DBRS"

    def __init__(self, **kwargs):
        """
        Initializes a new BackupDestinationDetailsSummary object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param backup_destination_attach_history:
            The value to assign to the backup_destination_attach_history property of this BackupDestinationDetailsSummary.
        :type backup_destination_attach_history: list[datetime]

        :param space_utilized_in_gbs:
            The value to assign to the space_utilized_in_gbs property of this BackupDestinationDetailsSummary.
        :type space_utilized_in_gbs: int

        :param time_at_which_storage_details_are_updated:
            The value to assign to the time_at_which_storage_details_are_updated property of this BackupDestinationDetailsSummary.
        :type time_at_which_storage_details_are_updated: datetime

        :param type:
            The value to assign to the type property of this BackupDestinationDetailsSummary.
            Allowed values for this property are: "NFS", "RECOVERY_APPLIANCE", "OBJECT_STORE", "LOCAL", "DBRS", 'UNKNOWN_ENUM_VALUE'.
            Any unrecognized values returned by a service will be mapped to 'UNKNOWN_ENUM_VALUE'.
        :type type: str

        :param id:
            The value to assign to the id property of this BackupDestinationDetailsSummary.
        :type id: str

        :param vpc_user:
            The value to assign to the vpc_user property of this BackupDestinationDetailsSummary.
        :type vpc_user: str

        :param vpc_password:
            The value to assign to the vpc_password property of this BackupDestinationDetailsSummary.
        :type vpc_password: str

        :param internet_proxy:
            The value to assign to the internet_proxy property of this BackupDestinationDetailsSummary.
        :type internet_proxy: str

        :param dbrs_policy_id:
            The value to assign to the dbrs_policy_id property of this BackupDestinationDetailsSummary.
        :type dbrs_policy_id: str

        """
        self.swagger_types = {
            'backup_destination_attach_history': 'list[datetime]',
            'space_utilized_in_gbs': 'int',
            'time_at_which_storage_details_are_updated': 'datetime',
            'type': 'str',
            'id': 'str',
            'vpc_user': 'str',
            'vpc_password': 'str',
            'internet_proxy': 'str',
            'dbrs_policy_id': 'str'
        }

        self.attribute_map = {
            'backup_destination_attach_history': 'backupDestinationAttachHistory',
            'space_utilized_in_gbs': 'spaceUtilizedInGBs',
            'time_at_which_storage_details_are_updated': 'timeAtWhichStorageDetailsAreUpdated',
            'type': 'type',
            'id': 'id',
            'vpc_user': 'vpcUser',
            'vpc_password': 'vpcPassword',
            'internet_proxy': 'internetProxy',
            'dbrs_policy_id': 'dbrsPolicyId'
        }

        self._backup_destination_attach_history = None
        self._space_utilized_in_gbs = None
        self._time_at_which_storage_details_are_updated = None
        self._type = None
        self._id = None
        self._vpc_user = None
        self._vpc_password = None
        self._internet_proxy = None
        self._dbrs_policy_id = None

    @property
    def backup_destination_attach_history(self):
        """
        Gets the backup_destination_attach_history of this BackupDestinationDetailsSummary.
        The timestamps at which this backup destination is used as the preferred destination to host the Autonomous Container Database backups.


        :return: The backup_destination_attach_history of this BackupDestinationDetailsSummary.
        :rtype: list[datetime]
        """
        return self._backup_destination_attach_history

    @backup_destination_attach_history.setter
    def backup_destination_attach_history(self, backup_destination_attach_history):
        """
        Sets the backup_destination_attach_history of this BackupDestinationDetailsSummary.
        The timestamps at which this backup destination is used as the preferred destination to host the Autonomous Container Database backups.


        :param backup_destination_attach_history: The backup_destination_attach_history of this BackupDestinationDetailsSummary.
        :type: list[datetime]
        """
        self._backup_destination_attach_history = backup_destination_attach_history

    @property
    def space_utilized_in_gbs(self):
        """
        Gets the space_utilized_in_gbs of this BackupDestinationDetailsSummary.
        The total space utilized (in GBs) by this Autonomous Container Database on this backup destination, rounded to the nearest integer.


        :return: The space_utilized_in_gbs of this BackupDestinationDetailsSummary.
        :rtype: int
        """
        return self._space_utilized_in_gbs

    @space_utilized_in_gbs.setter
    def space_utilized_in_gbs(self, space_utilized_in_gbs):
        """
        Sets the space_utilized_in_gbs of this BackupDestinationDetailsSummary.
        The total space utilized (in GBs) by this Autonomous Container Database on this backup destination, rounded to the nearest integer.


        :param space_utilized_in_gbs: The space_utilized_in_gbs of this BackupDestinationDetailsSummary.
        :type: int
        """
        self._space_utilized_in_gbs = space_utilized_in_gbs

    @property
    def time_at_which_storage_details_are_updated(self):
        """
        Gets the time_at_which_storage_details_are_updated of this BackupDestinationDetailsSummary.
        The latest timestamp when the backup destination details, such as 'spaceUtilized,' are updated.


        :return: The time_at_which_storage_details_are_updated of this BackupDestinationDetailsSummary.
        :rtype: datetime
        """
        return self._time_at_which_storage_details_are_updated

    @time_at_which_storage_details_are_updated.setter
    def time_at_which_storage_details_are_updated(self, time_at_which_storage_details_are_updated):
        """
        Sets the time_at_which_storage_details_are_updated of this BackupDestinationDetailsSummary.
        The latest timestamp when the backup destination details, such as 'spaceUtilized,' are updated.


        :param time_at_which_storage_details_are_updated: The time_at_which_storage_details_are_updated of this BackupDestinationDetailsSummary.
        :type: datetime
        """
        self._time_at_which_storage_details_are_updated = time_at_which_storage_details_are_updated

    @property
    def type(self):
        """
        **[Required]** Gets the type of this BackupDestinationDetailsSummary.
        Type of the database backup destination.

        Allowed values for this property are: "NFS", "RECOVERY_APPLIANCE", "OBJECT_STORE", "LOCAL", "DBRS", 'UNKNOWN_ENUM_VALUE'.
        Any unrecognized values returned by a service will be mapped to 'UNKNOWN_ENUM_VALUE'.


        :return: The type of this BackupDestinationDetailsSummary.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this BackupDestinationDetailsSummary.
        Type of the database backup destination.


        :param type: The type of this BackupDestinationDetailsSummary.
        :type: str
        """
        allowed_values = ["NFS", "RECOVERY_APPLIANCE", "OBJECT_STORE", "LOCAL", "DBRS"]
        if not value_allowed_none_or_none_sentinel(type, allowed_values):
            type = 'UNKNOWN_ENUM_VALUE'
        self._type = type

    @property
    def id(self):
        """
        Gets the id of this BackupDestinationDetailsSummary.
        The `OCID`__ of the backup destination.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :return: The id of this BackupDestinationDetailsSummary.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this BackupDestinationDetailsSummary.
        The `OCID`__ of the backup destination.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :param id: The id of this BackupDestinationDetailsSummary.
        :type: str
        """
        self._id = id

    @property
    def vpc_user(self):
        """
        Gets the vpc_user of this BackupDestinationDetailsSummary.
        For a RECOVERY_APPLIANCE backup destination, the Virtual Private Catalog (VPC) user that is used to access the Recovery Appliance.


        :return: The vpc_user of this BackupDestinationDetailsSummary.
        :rtype: str
        """
        return self._vpc_user

    @vpc_user.setter
    def vpc_user(self, vpc_user):
        """
        Sets the vpc_user of this BackupDestinationDetailsSummary.
        For a RECOVERY_APPLIANCE backup destination, the Virtual Private Catalog (VPC) user that is used to access the Recovery Appliance.


        :param vpc_user: The vpc_user of this BackupDestinationDetailsSummary.
        :type: str
        """
        self._vpc_user = vpc_user

    @property
    def vpc_password(self):
        """
        Gets the vpc_password of this BackupDestinationDetailsSummary.
        For a RECOVERY_APPLIANCE backup destination, the password for the VPC user that is used to access the Recovery Appliance.


        :return: The vpc_password of this BackupDestinationDetailsSummary.
        :rtype: str
        """
        return self._vpc_password

    @vpc_password.setter
    def vpc_password(self, vpc_password):
        """
        Sets the vpc_password of this BackupDestinationDetailsSummary.
        For a RECOVERY_APPLIANCE backup destination, the password for the VPC user that is used to access the Recovery Appliance.


        :param vpc_password: The vpc_password of this BackupDestinationDetailsSummary.
        :type: str
        """
        self._vpc_password = vpc_password

    @property
    def internet_proxy(self):
        """
        Gets the internet_proxy of this BackupDestinationDetailsSummary.
        Proxy URL to connect to object store.


        :return: The internet_proxy of this BackupDestinationDetailsSummary.
        :rtype: str
        """
        return self._internet_proxy

    @internet_proxy.setter
    def internet_proxy(self, internet_proxy):
        """
        Sets the internet_proxy of this BackupDestinationDetailsSummary.
        Proxy URL to connect to object store.


        :param internet_proxy: The internet_proxy of this BackupDestinationDetailsSummary.
        :type: str
        """
        self._internet_proxy = internet_proxy

    @property
    def dbrs_policy_id(self):
        """
        Gets the dbrs_policy_id of this BackupDestinationDetailsSummary.
        The `OCID`__ of the DBRS policy used for backup.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :return: The dbrs_policy_id of this BackupDestinationDetailsSummary.
        :rtype: str
        """
        return self._dbrs_policy_id

    @dbrs_policy_id.setter
    def dbrs_policy_id(self, dbrs_policy_id):
        """
        Sets the dbrs_policy_id of this BackupDestinationDetailsSummary.
        The `OCID`__ of the DBRS policy used for backup.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :param dbrs_policy_id: The dbrs_policy_id of this BackupDestinationDetailsSummary.
        :type: str
        """
        self._dbrs_policy_id = dbrs_policy_id

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
