# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20220901


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class AttachManagedInstanceGroupToProfileDetails(object):
    """
    Provides the information used to attach a managed instance group to a profile.
    """

    def __init__(self, **kwargs):
        """
        Initializes a new AttachManagedInstanceGroupToProfileDetails object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param managed_instance_group_id:
            The value to assign to the managed_instance_group_id property of this AttachManagedInstanceGroupToProfileDetails.
        :type managed_instance_group_id: str

        """
        self.swagger_types = {
            'managed_instance_group_id': 'str'
        }

        self.attribute_map = {
            'managed_instance_group_id': 'managedInstanceGroupId'
        }

        self._managed_instance_group_id = None

    @property
    def managed_instance_group_id(self):
        """
        **[Required]** Gets the managed_instance_group_id of this AttachManagedInstanceGroupToProfileDetails.
        The `OCID`__ of the managed instance group that the instance will be associated with.

        __ https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm


        :return: The managed_instance_group_id of this AttachManagedInstanceGroupToProfileDetails.
        :rtype: str
        """
        return self._managed_instance_group_id

    @managed_instance_group_id.setter
    def managed_instance_group_id(self, managed_instance_group_id):
        """
        Sets the managed_instance_group_id of this AttachManagedInstanceGroupToProfileDetails.
        The `OCID`__ of the managed instance group that the instance will be associated with.

        __ https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm


        :param managed_instance_group_id: The managed_instance_group_id of this AttachManagedInstanceGroupToProfileDetails.
        :type: str
        """
        self._managed_instance_group_id = managed_instance_group_id

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
